"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var core_1 = require('@angular/core');
require('./jsoneditor.min.js');
//require('./jsoneditor.min.js'); //Works too
// https://github.com/AngularClass/angular2-webpack-starter/issues/570
//var JSONEditor = require('json-editor');
// http://stackoverflow.com/questions/32173118/how-do-i-import-a-library-into-node-without-a-typescript-tsd-definition
//import * as JSONEditor from 'json-editor';
//declare var JSONEditor:any;
// Cheez-o-max way to import js lib that don't provide their own typings (directly imported in src/index.html for now)
// http://stackoverflow.com/questions/27417107/how-use-an-external-non-typescript-library-from-typescript-without-d-ts
// https://github.com/jdorn/json-editor/issues/590
// We could also write their typings by providing ambient definition
// Exeample at https://github.com/im-tollu/broken-import/blob/master/app/app.component.ts
var AnnotationForm = (function () {
    function AnnotationForm() {
        this.onSave = new core_1.EventEmitter();
        this.editedAnnotation = {};
        this.editedSchema = {};
        this.editor = null;
        this.mockAnnotation = {};
        this.mockJsonSchema = {};
        this.mockAnnotation = {
            "name": "Jeremy Dorn",
            "age": 25,
            "favorite_color": "#ffa500",
            "location": {
                "city": "San Francisco",
                "state": "CA",
                "citystate": "San Francisco, CA"
            },
            "pets": [
                {
                    "type": "dog",
                    "name": "Walter"
                }
            ]
        };
        this.mockJsonSchema = {
            "title": "Person",
            "type": "object",
            "properties": {
                "name": {
                    "type": "string",
                    "description": "First and Last name",
                    "minLength": 4
                },
                "age": {
                    "type": "integer",
                    "minimum": 18,
                    "maximum": 99
                },
                "favorite_color": {
                    "type": "string",
                    "format": "color",
                    "title": "favorite color"
                },
                "gender": {
                    "type": "string",
                    "enum": [
                        "male",
                        "female"
                    ]
                },
                "location": {
                    "type": "object",
                    "title": "Location",
                    "properties": {
                        "city": {
                            "default": "San Francisco",
                            "type": "string"
                        },
                        "state": {
                            "type": "string"
                        },
                        "citystate": {
                            "type": "string",
                            "description": "This is generated automatically from the previous two fields",
                            "template": "{{city}}, {{state}}",
                            "watch": {
                                "city": "location.city",
                                "state": "location.state"
                            }
                        }
                    }
                },
                "pets": {
                    "type": "array",
                    "format": "table",
                    "title": "Pets",
                    "uniqueItems": true,
                    "items": {
                        "type": "object",
                        "title": "Pet",
                        "properties": {
                            "type": {
                                "type": "string",
                                "enum": [
                                    "cat",
                                    "dog",
                                    "bird",
                                    "reptile",
                                    "other"
                                ]
                            },
                            "name": {
                                "type": "string"
                            }
                        }
                    }
                }
            }
        };
    }
    AnnotationForm.prototype.injectAnnotationInSchema = function (schema, annotation) {
        //TODO: Inject annotation in default fields
        return schema;
    };
    AnnotationForm.prototype.saveAnnotation = function () {
        if (this.editor.validate()) {
            this.editedAnnotation = this.editor.getValue();
            this.editedSchema = this.editor.schema;
            //TODO: Schema probably must be cleaned before being returned(propertyOrder, default values, etc.)
            this.onSave.emit({ annotation: this.editedAnnotation, schema: this.editedSchema });
        }
    };
    AnnotationForm.prototype.ngOnInit = function () {
        //I wish their was a better way of doing this: http://stackoverflow.com/questions/35528395/angular-2-make-input-on-directive-required
        //Validate required Inputs and Outputs are defined
        if (!this.onSave)
            throw new Error("Event 'onSave' is required");
        if (!this.schema)
            throw new Error("Attribute 'schema' is required");
        if (!this.annotation)
            throw new Error("Attribute 'annotation' is required");
        var element = document.getElementById('editor_holder');
        var options = {
            ajax: false,
            disable_array_add: false,
            disable_array_delete: false,
            disable_array_reorder: false,
            disable_collapse: false,
            disable_edit_json: true,
            disable_properties: false,
            form_name_root: 'form_name_root',
            iconlib: 'bootstrap3',
            no_additional_properties: false,
            refs: {},
            required_by_default: false,
            keep_oneof_values: true,
            schema: this.injectAnnotationInSchema(this.mockJsonSchema, this.mockAnnotation),
            show_errors: "interaction",
            startval: null,
            template: 'default',
            theme: 'bootstrap3' //	The CSS theme to use. See the CSS Integration section below for more info.	html
        };
        this.editor = new JSONEditor(element, options);
    };
    AnnotationForm.prototype.ngOnDestroy = function () {
        // Speak now or forever hold your peace
    };
    AnnotationForm.prototype.ngDoCheck = function () {
        // Custom change detection
    };
    AnnotationForm.prototype.ngOnChanges = function (changes) {
        // Called right after our bindings have been checked but only
        // if one of our bindings has changed.
        //
        // changes is an object of the format:
        // {
        //   'prop': PropertyUpdate
        // }
    };
    AnnotationForm.prototype.ngAfterContentInit = function () {
        // Component content has been initialized
    };
    AnnotationForm.prototype.ngAfterContentChecked = function () {
        // Component content has been Checked
    };
    AnnotationForm.prototype.ngAfterViewInit = function () {
        // Component views are initialized
    };
    AnnotationForm.prototype.ngAfterViewChecked = function () {
        var yolo;
        // Component views have been checked
    };
    __decorate([
        core_1.Output()
    ], AnnotationForm.prototype, "onSave");
    __decorate([
        core_1.Input('schema')
    ], AnnotationForm.prototype, "schema");
    __decorate([
        core_1.Input('annotation')
    ], AnnotationForm.prototype, "annotation");
    AnnotationForm = __decorate([
        //here or custom-typings.d.ts but current way webstorm wont give warning.
        core_1.Component({
            selector: 'annotation-form',
            styles: ["\n  "],
            template: "\n    <h1>Annotation Form</h1>\n    <div id=\"editor_holder\"></div>\n    <button (click)=\"saveAnnotation()\" type=\"button\" title=\"Save annotation & schema\" class=\"btn btn-default\"><i class=\"glyphicon glyphicon-save\"></i> Save annotation & schema</button>\n  "
        })
    ], AnnotationForm);
    return AnnotationForm;
}());
exports.AnnotationForm = AnnotationForm;
//# sourceMappingURL=annotation-form.component.js.map